


#include "stdresp.h"

// search a list of standardized values
double stdResSearchArray(double * a, double v) {
    double sv, Esv;
    int i;

    Esv = 99.9;
    
    for(i = 0; a[i] != 0.0; i++) {
      if (ABS(a[i] - v) < Esv) {
        Esv = ABS(a[i] - v);
	sv = a[i];
      } 
    }
    
    return sv;
}

// find the resistance closest to the given value
double stdResClosest(uint8_t series, double v) {

    int E = 0;
    double sv[7], rv;
    int i;

    // we need to reduce v to 1.0 -> 9.99
    // no, turns out that the float format is all screwie and we cant just cheat
    while ((v < 1.0) || (v >= 10.0) ) {
      if (0) {
      } else if (v < 1.0) {
        v *= 10; E--;
      } else if (v >= 10.0) {
        v /= 10; E++;
      }
    }

    for(i = 0; i < 7; sv[i++] = 0.0);

    if (series & E6)   sv[0] = stdResSearchArray(VE6, v);
    if (series & E12)  sv[1] = stdResSearchArray(VE12, v);
    if (series & E24)  sv[2] = stdResSearchArray(VE24, v);
    if (series & E48)  sv[3] = stdResSearchArray(VE48, v);
    if (series & E96)  sv[4] = stdResSearchArray(VE96, v);
    if (series & E192) sv[5] = stdResSearchArray(VE192, v);
    
    rv = stdResSearchArray(sv, v); // hah, well that came in handy!
    rv *= pow(10, E);
    return rv;
    
}

void stdResPrintArray( double * p) {

  for (; *p != 0.0; p++) printf("%f ", *p);
  printf("\n");  

}


double * stdResGetValueArray(int8_t exp, uint8_t series) {
  
  double * rv      = NULL;
  double * rvp     = NULL;
  size_t arraySize = 0;
  double * ap;

  if (series & E6)   arraySize += sizeof(VE6);
  if (series & E12)  arraySize += sizeof(VE12);
  if (series & E24)  arraySize += sizeof(VE24);
  if (series & E48)  arraySize += sizeof(VE48);
  if (series & E96)  arraySize += sizeof(VE96);
  if (series & E192) arraySize += sizeof(VE192);
    
  rv = malloc(arraySize); 
  rvp = rv;
  
  if (series & E6)    for (ap = VE6;   *ap != 0.0; ap++, rvp++) *rvp = *ap * pow(10, exp);
  if (series & E12)   for (ap = VE12;  *ap != 0.0; ap++, rvp++) *rvp = *ap * pow(10, exp);
  if (series & E24)   for (ap = VE24;  *ap != 0.0; ap++, rvp++) *rvp = *ap * pow(10, exp);
  if (series & E48)   for (ap = VE48;  *ap != 0.0; ap++, rvp++) *rvp = *ap * pow(10, exp);
  if (series & E96)   for (ap = VE96;  *ap != 0.0; ap++, rvp++) *rvp = *ap * pow(10, exp);
  if (series & E192)  for (ap = VE192; *ap != 0.0; ap++, rvp++) *rvp = *ap * pow(10, exp);
  
  *rvp = 0.0;
  
  return rv;

}

// get a big array with a bunch of value in it
// there may be duplicates
// array is malloc'ed
double * GetValueArrays(int8_t expStart, int8_t expEnd, uint8_t series) {
  
  int8_t i;
  
  if (expStart > expEnd) { // switcheroo? whats with you!
    i = expEnd;
    expEnd = expStart;
    expStart = i;
  }
  
  // sizeof series * (expEnd - expStart + 1)
  


}
